mod Mauxa logic: 'cl'

incl Mtex

rem 
  \para \bf  [CL] Catalan pairing function.  \end The Catalan pairing function 
  \ft x,y \end, written as \ft 'x,y' \end, is pre-defined in CL. The following 
  properties of the pairing function are built in into the CL theorem prover: 
  \eq* 
    x1,x2 = y1,y2 <-> x1 = y1 & x2 = y2
  \end
  \eq* 
    x,y = 0 <-> \f
  \end
  \para Moreover, we have 
  \eq* 
    x = Tex2_bappl1(Tex0_tau,x) <-> \f
  \end
  \para for terms \ft Tex2_bappl1(Tex0_tau,x) \end of the form 
  \eq* 
    Tex2_equiv(Tex2_bappl1(Tex0_tau,x),x,y)
  \end
  \eq* 
    Tex2_equiv(Tex2_bappl1(Tex0_tau,x),y,x)
  \end
  \eq* 
    Tex2_equiv(Tex2_bappl1(Tex0_tau,x),(x,y1),y2)
  \end
  \eq* 
    Tex2_equiv(Tex2_bappl1(Tex0_tau,x),(y1,x),y2)
  \end
  \eq* 
    Tex2_equiv(Tex2_bappl1(Tex0_tau,x),y1,x,y2)
  \end
  \eq* 
    Tex2_equiv(Tex2_bappl1(Tex0_tau,x),y1,y2,x)
  \end
  \eq* 
    Tex0_dotsc
  \end

rem 
  \para \it  Projection functions.  \end 

fun Proj1 'Tex_f1_pp_proj1'
  Proj1(0) = 0
  Proj1(v,w) = v

fun Proj2 'Tex_f1_pp_proj2'
  Proj2(0) = 0
  Proj2(v,w) = w

rem 
  \para \it  Iteration of the second projection.  \end 

fun/2 Iproj2 'Tex_f2_pp_iproj2'
  Iproj2(0,x) = x
  Iproj2(n+1,x) = Proj2 Iproj2(n,x)

thm Iproj2_mono_zero
  Iproj2(n,0) = 0
proof 
 ind N; n @ 0; n
  proved
  proved..

thm Iproj2_plus
  Iproj2(m+n,x) = Iproj2(m,Iproj2(n,x))
proof 
 ind N; m @ 0; m
  proved
  proved..

thm Iproj2_proj2
  Proj2 Iproj2(n,x) = Iproj2(n,Proj2(x))
proof 
 use Iproj2_plus; n; 1; x proved..

